/*
  UMainForm.cpp

  This file is part of BIN2HEXGUI.

  BIN2HEXGUI was developed by Synapse(Hiroshi Tanigawa) in 2014.  BIN2HEXGUI
  is originally distributed at "Synapse's history of making gadgets"
  <http://www3.big.or.jp/~schaft/hardware/>

  BIN2HEXGUI is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  BIN2HEXGUI is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BIN2HEXGUI.  If not, see <http://www.gnu.org/licenses/>.
*/

//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "UMainForm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ConvertBtnClick(TObject *Sender)
{
  const int BufSize = 32;
  FILE *f1,*f2;
  unsigned char buf[BufSize];
  int cnt;
  int addr;
  int sum;

  if(!HexOpenDlg->Execute()) return;

  f1=fopen(HexOpenDlg->FileName.c_str(),"rb");
  if(f1==NULL) {
    MessageBox(Handle,"t@CJ܂B",Caption.c_str(),MB_ICONERROR|MB_OK);
    return;
  }
  try {
    f2=fopen(ChangeFileExt(HexOpenDlg->FileName,".hex").c_str(),"wt");
    try {
      try {
        addr=0;
        do {
          cnt=fread(buf,1,BufSize,f1);
          if(cnt>0) {
            if(fprintf(f2,":%02X%04X00",cnt,addr)==EOF) throw 0;
            sum=cnt+(addr>>8)+(addr&0xff);
            for(int i=0; i<cnt; i++) {
              if(fprintf(f2,"%02X",buf[i])==EOF) throw 0;
              sum+=buf[i];
            } // for i
            sum=((~sum)+1)&0xff;
            fprintf(f2,"%02X\n",sum);
          } // if
          addr+=cnt;
        } while(cnt>0);
        if (fprintf(f2,":00000001FF\n")==EOF) throw 0;
        MessageBox(Handle,"ϊI܂B",Caption.c_str(),MB_ICONINFORMATION|MB_OK);
      }
      catch(int) {
         MessageBox(Handle,"t@C݂̏Ɏs܂B",Caption.c_str(),MB_ICONERROR|MB_OK);
      }
    }
    __finally {
      fclose(f2);
    }
  }
  __finally {
    fclose(f1);
  }


}
//---------------------------------------------------------------------------


